#!/usr/bin/env python3

import os
import sys
import dropbox
from dropbox.exceptions import ApiError

def process_folders(current_state, entries):
    n = 0
    for entry in entries:
        if type(entry) == dropbox.files.FolderMetadata:
            n += 1
            result = dbx.files_list_folder(path=entry.path_display)
            t = process_folders({}, result.entries)
            n += t

        if isinstance(entry, dropbox.files.FileMetadata):
            current_state[entry.path_lower] = entry
        elif isinstance(entry, dropbox.files.DeletedMetadata):
            current_state.pop(entry.path_lower, None)
    return n

def path_exists(path):
    try:
        dbx.files_get_metadata(path)
        return True
    except ApiError as e:
        if e.error.get_path().is_not_found():
            return False
        raise

access_token = os.environ.get('DROPBOX_TOKEN')
if access_token == None:
    print("DROPBOX_TOKEN is not set!")
    sys.exit()

dbx = dropbox.Dropbox(access_token)

directory = "/LXF"
if path_exists(directory):
    print("Directory", directory, "exists!")
else:
    print("Directory", directory, "does not exist!")
    sys.exit()

result = dbx.files_list_folder(path=directory)
nfolders_current = process_folders({}, result.entries)
print("Found", nfolders_current, "folders.", end = '\n')
