#!/usr/bin/env python3

import os
import sys
import dropbox

def process_folder_entries(current_state, entries):
    n = 0
    for entry in entries:
        if type(entry) == dropbox.files.FileMetadata:
            n += 1
        elif type(entry) == dropbox.files.FolderMetadata:
            result = dbx.files_list_folder(path=entry.path_display)
            t = process_folder_entries({}, result.entries)
            n += t

        if isinstance(entry, dropbox.files.FileMetadata):
            current_state[entry.path_lower] = entry
        elif isinstance(entry, dropbox.files.DeletedMetadata):
            current_state.pop(entry.path_lower, None)
    return n

access_token = os.environ.get('DROPBOX_TOKEN')
if access_token == None:
    print("DROPBOX_TOKEN is not set!")
    sys.exit()

dbx = dropbox.Dropbox(access_token)

result = dbx.files_list_folder(path="/LXF")
nfiles_current = process_folder_entries({}, result.entries)
print("Found", nfiles_current, "files.", end = '\n')
