#!/usr/bin/env python3

import dropbox
import os
from stat import *
import sys

access_token = os.environ.get('DROPBOX_UPLOAD_TOKEN')
if access_token == None:
    print("DROPBOX_UPLOAD_TOKEN is not set!")
    sys.exit()

dbx = dropbox.Dropbox(access_token)

if len(sys.argv) != 3:
    print("Usage: script input DROPBOX_PATH")
    sys.exit()

input = sys.argv[1]
DROPBOX_PATH = sys.argv[2]

# Check if the file exists and is a regular file
mode = os.stat(input)[ST_MODE]
if S_ISDIR(mode):
    print(input, "is a directory!")
    sys.exit()
elif S_ISREG(mode):
    print(input, "is a regular file!")
else:
    print(input, "is not a regular file!")
    sys.exit()

filename = os.path.basename(input)
mode = dropbox.files.WriteMode('add', None)
# mode = dropbox.files.WriteMode('overwrite', None)
targetfile = DROPBOX_PATH + "/" + filename

try:
    dbx.files_upload(open(input, "rb").read(), path = targetfile,  mode = mode)
    print(input, "Uploaded to Dropbox")
except Exception as e:
    print("**" + str(e))

upload_link = dbx.sharing_create_shared_link(targetfile)
shared_URL = upload_link.url
print(shared_URL)
